package com.usky.dxtop.service.impl;


import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.usky.dxtop.common.core.page.CommonPage;
import com.usky.dxtop.mapper.DeptMapper;
import com.usky.dxtop.model.Dept;
import com.usky.dxtop.service.DeptService;
import com.usky.dxtop.service.vo.StaffRequest;
import org.springframework.stereotype.Service;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author yq
 * @since 2021-09-28
 */
@Service
public class DeptServiceImpl extends ServiceImpl<DeptMapper, Dept> implements DeptService {

    @Override
    public CommonPage<Dept> page(StaffRequest staffRequest) {
        IPage<Dept> page = new Page<>(staffRequest.getCurrent(), staffRequest.getSize());
        LambdaQueryWrapper<Dept> queryWrapper = Wrappers.lambdaQuery();
        queryWrapper.eq(StringUtils.isNotBlank(staffRequest.getName()),Dept::getName,staffRequest.getName())
                .between(null != staffRequest.getStartTime() && null != staffRequest.getEndTime(),Dept::getCreateTime,
                        staffRequest.getStartTime(),staffRequest.getEndTime());
        page = this.page(page,queryWrapper);
        return new CommonPage<>(page.getRecords(),page.getTotal(),page.getCurrent(),page.getSize());
    }
}
